// Application Class

#include <windows.h>

#include "App.h"

#include "text.h"

#include "server.h"

#pragma warn -par  // No "Param never used warning"
int CApp::Main(HINSTANCE hInstance, LPSTR lpCmdLine, int nCmdShow)
{

	WNDCLASSEX wcex;			 // Window class structure
	HWND hWnd;					 // Handle of the message window
    MSG msg;


    // Register the windows class:

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC) GlobalWndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= NULL;
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW + 1);
	wcex.lpszMenuName	= NULL;
	wcex.lpszClassName	= WINDOW_CLASS;
	wcex.hIconSm		= NULL;

	if (!RegisterClassEx(&wcex))
		return 0;

    // Create the Window

	hWnd = CreateWindowEx(NULL, WINDOW_CLASS, MUD_WINDOWTITLE,
        WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_THICKFRAME | WS_MINIMIZEBOX,
		GetSystemMetrics(SM_CXSCREEN) / 2 - 300 / 2,
		GetSystemMetrics(SM_CYSCREEN) / 2 - 200 / 2,
		300, 200, NULL, NULL, hInstance, this);

    if(!hWnd) return 0;

	ShowWindow(hWnd, SW_SHOW);
	UpdateWindow(hWnd);

    // Init winsock2

    int error = WSAStartup(0x0202, &wsaData);
    if(error)
	{
        MessageBox(hWnd, "Could not Init Winsock2", "ERROR", MB_OK);
        return 0;
    }
	else if(wsaData.wVersion != 0x0202)
    {
        MessageBox(hWnd, "Could not Init Winsock2 - Wrong Version", "ERROR", MB_OK);
        WSACleanup();
        return 0;
    }

    // Open the listen socket (this has the side effect of creating the CServer singleton)
    if( CServer::GetServer()->socket.CreateSocket(hWnd, SM_WINSOCK, MUD_LSTNPORT) == 0)
    {
        MessageBox(hWnd, "Could not create listen socket", "ERROR", MB_OK);
    }


	// Message loop
    
	while(GetMessage(&msg, NULL, 0, 0))
	{
        TranslateMessage(&msg);
        DispatchMessage(&msg);
	}

	return 1;
}
#pragma warn .par

/// Main window procedure
LRESULT CALLBACK CApp::WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_CREATE:
			break;

		case WM_SIZE:
			break;

		case WM_CLOSE:
			// Quit the program
			PostQuitMessage(0);
			break;

		case WM_PAINT:
			PAINTSTRUCT ps;
			HDC hdc;
			hdc = BeginPaint(hWnd, &ps);
			RECT rt;
			GetClientRect(hWnd, &rt);
			
			DrawText(hdc, MUD_TITLE, strlen(MUD_TITLE), &rt, DT_CENTER);

            // Note: the folowing line will move the rectangle down so you can add more text
			// rt.top += 16;

			EndPaint(hWnd, &ps);
			break;

        case SM_WINSOCK:
            CServer::GetServer()->SocketMessageHandler(wParam, lParam);

		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
	}

	return 0;
}

