// Application Class

#ifndef APP_H_INCLUDED
#define APP_H_INCLUDED

#define WINDOW_CLASS "MUD_SRV"

// Sever Message - Winsock will send these informing about socket events
// WM_USER represents the start of the user defined messages. Here we create a new message.
#define SM_WINSOCK WM_USER+1

class CApp
{
public:

    // Constructor
	CApp() {}
    // Deconstructor
	virtual ~CApp() {}

    // The main application function (called directly from WinMain)
    int Main(HINSTANCE hInstance, LPSTR lpCmdLine, int nCmdShow);

	/// Window procedure that routes the messages to the CApp class (note static)
	static LRESULT CALLBACK GlobalWndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
	{
		LPCREATESTRUCT cs;

		if (message == WM_NCCREATE)
		{
			cs = (LPCREATESTRUCT) lParam;
			SetWindowLong(hWnd, GWL_USERDATA, (LONG) cs->lpCreateParams);
		}

		CApp *pApp = (CApp *) GetWindowLong(hWnd, GWL_USERDATA);
		return pApp->WndProc(hWnd, message, wParam, lParam);
	}

private:

    // The application's message processor.
    // CApp::GlobalWndProc calls this and passes on the message
    LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);

    // Winsock2 Data
    WSADATA wsaData;
};


#endif // APP_H_INCLUDED
