// A normal socket

#ifndef NORMSOCK_H_INCLUDED
#define NORMSOCK_H_INCLUDED

#include "lstnsock.h"
#include "sock.h"

// A normal socket that can either be used to connect to a server as a client
// or can be given a connection from the server (listening) socket

class CNormalSocket : public CSocket
{
public:

    CNormalSocket();
    ~CNormalSocket();

    // Take a connection from a listening (server) socket and give it its own socket.
    int CreateSocket(CListenSocket* serversock);

    // Manualy create a socket. Used when connecting to a server as a client.
    int CreateSocket(char* ip, int port, HWND hWnd, UINT message);

    // Read from the socket into dest
    void GetText(char* dest, int length);

protected:

    // Contains the address information of a connection accepted from a listening socket
    SOCKADDR asyncaddr;
};


#endif // NORMSOCK_H_INCLUDED
